/etc/debootstrap/chroot-script is in grml-debootstrap 0.59.
This file is owned by root:root, with mode 0o755.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432 433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456 457 458 459 460 461 462 463 464 465 466 467 468 469 470 471 472 473 474 475 476 477 478 479 480 481 482 483 484 485 486 487 488 489 490 491 492 493 494 495 496 497 498 499 500 501 502 503 504 505 506 507 508 509 510 511 512 513 514 515 516 517 518 519 520 521 522 523 524 525 526 527 528 529 530 531 532 533 534 535 536 537 538 539 540 541 542 543 544 545 546 547 548 549 550 551 552 553 554 555 556 557 558 559 560 561 562 563 564 565 566 567 568 569 570 571 572 573 574 575 576 577 578 579 580 581 582 583 584 585 586 587 588 589 590 591 592 593 594 595 596 597 598 599 600 601 602 603 604 605 606 607 608 609 610 611 612 613 614 615 616 617 618 619 620 621 622 623 624 625 626 627 628 629 630 631 632 633 634 635 636 637 638 639 640 641 642 | #!/bin/sh
# Filename: /etc/debootstrap/chroot-script
# Purpose: script executed in chroot when installing Debian via grml-debootstrap
# Authors: grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
# Bug-Reports: see http://grml.org/bugs/
# License: This file is licensed under the GPL v2.
################################################################################
# GRML_CHROOT_SCRIPT_MARKER - do not remove this line unless you want to keep
# this script as /bin/chroot-script on your new installed system
################################################################################
. /etc/debootstrap/config || exit 1
. /etc/debootstrap/variables || exit 1
[ -r /proc/1 ] || mount -t proc none /proc
# variable checks {{{
# use aptitude only if it's available
if [ -x /usr/bin/aptitude ] ; then
APTUPDATE='aptitude update'
# Debian ISOs do not contain signed Release files
if [ -n "$ISO" ] ; then
APTINSTALL="aptitude -y --allow-untrusted --without-recommends install $DPKG_OPTIONS"
APTUPGRADE='aptitude -y --allow-untrusted safe-upgrade'
else
APTINSTALL="aptitude -y --without-recommends install $DPKG_OPTIONS"
APTUPGRADE='aptitude -y safe-upgrade'
fi
else
APTINSTALL="apt-get --force-yes -y --no-install-recommends install $DPKG_OPTIONS"
APTUPDATE='apt-get update'
APTUPGRADE='apt-get --force-yes -y upgrade'
fi
if [ -z "$STAGES" ] ; then
STAGES='/etc/debootstrap/stages'
[ -d "$STAGES" ] || mkdir -p "$STAGES"
fi
# }}}
# helper functions {{{
stage() {
if [ -n "$2" ] ; then
echo "$2" > "$STAGES/$1"
return 0
elif grep -q done "$STAGES/$1" 2>/dev/null ; then
echo " [*] Notice: stage $1 has been executed already, skipping execution therefore.">&2
return 1
fi
echo " Executing stage ${1}"
return 0
}
askpass() {
# read -s emulation for dash. result is in $resp.
set -o noglob
[ -t 0 ] && stty -echo
read resp
[ -t 0 ] && stty echo
set +o noglob
}
# }}}
# define chroot mirror {{{
chrootmirror() {
if [ -n "$KEEP_SRC_LIST" ] ; then
echo "KEEP_SRC_LIST has been set, skipping chrootmirror stage."
return
fi
if [ -z "$COMPONENTS" ] ; then
COMPONENTS='main contrib non-free'
fi
echo "Using repository components $COMPONENTS"
if [ -n "$ISO" ] ; then
echo "Adjusting sources.list for ISO (${ISO})."
echo "deb $ISO $RELEASE $COMPONENTS" > /etc/apt/sources.list
echo "Adding mirror entry (${MIRROR}) to sources.list."
[ -n "$MIRROR" ] && echo "deb $MIRROR $RELEASE $COMPONENTS" >> /etc/apt/sources.list || true
else
if [ -n "$MIRROR" ] ; then
echo "Adjusting sources.list for mirror (${MIRROR})."
echo "deb $MIRROR $RELEASE $COMPONENTS" > /etc/apt/sources.list
fi
fi
# add security.debian.org:
case "$RELEASE" in
unstable|sid) ;; # no security pool available
*)
echo "Adding security.debian.org to sources.list."
echo "deb http://security.debian.org ${RELEASE}/updates $COMPONENTS" >> /etc/apt/sources.list
;;
esac
}
# }}}
# remove local chroot mirror {{{
remove_chrootmirror() {
if [ -n "$KEEP_SRC_LIST" ] ; then
echo "KEEP_SRC_LIST has been set, skipping remove_chrootmirror stage."
return
fi
if [ -n "$ISO" ] ; then
echo "Removing ISO (${ISO}) from sources.list."
TMP_ISO=$(echo "$ISO" |sed 's#/#\\/#g')
sed -i "/deb $TMP_ISO $RELEASE $COMPONENTS/ D" /etc/apt/sources.list
else
if [ -n "$MIRROR" -a -n "$(echo $MIRROR|grep file:)" ] ; then
echo "Removing local mirror (${MIRROR}) from sources.list."
TMP_MIRROR=$(echo "$MIRROR" |sed 's#/#\\/#g')
sed -i "/deb $TMP_MIRROR $RELEASE $COMPONENTS/ D" /etc/apt/sources.list
echo "Adding fallback mirror entry (${FALLBACK_MIRROR}) to sources.list instead."
echo "deb $FALLBACK_MIRROR $RELEASE $COMPONENTS" >> /etc/apt/sources.list
fi
fi
}
# }}}
# set up grml repository {{{
grmlrepos() {
if [ -n "$GRMLREPOS" ] ; then
# user might have provided their own apt sources.list
if ! grep -q grml /etc/apt/sources.list.d/grml.list 2>/dev/null ; then
cat >> /etc/apt/sources.list.d/grml.list << EOF
# grml: stable repository:
deb http://deb.grml.org/ grml-stable main
deb-src http://deb.grml.org/ grml-stable main
# grml: testing/development repository:
deb http://deb.grml.org/ grml-testing main
deb-src http://deb.grml.org/ grml-testing main
EOF
fi
if apt-get update ; then
apt-get -y --allow-unauthenticated install grml-debian-keyring
apt-get update
else
# make sure we have the keys available for aptitude
gpg --keyserver subkeys.pgp.net --recv-keys F61E2E7CECDEA787
gpg --export F61E2E7CECDEA787 | apt-key add - || true # not yet sure
# why it's necessary, sometimes we get an error even though it works [mika]
fi
# make sure we install packages from Grml's pool only if not available
# from Debian!
if ! grep -q grml /etc/apt/preferences 2>/dev/null ; then
cat >> /etc/apt/preferences << EOF
// debian pool (default):
Package: *
Pin: release o=Debian
Pin-Priority: 996
// main grml-repository:
Package: *
Pin: origin deb.grml.org
Pin-Priority: 991
EOF
fi
fi
}
# }}}
# check available backports release version {{{
checkbackports() {
wget -q -O/dev/null http://backports.debian.org/debian-backports/dists/${1}-backports/Release
}
# }}}
# feature to provide Debian backports repos {{{
backportrepos() {
if [ -n "$BACKPORTREPOS" ] ; then
if ! checkbackports $RELEASE ; then
echo "Backports for ${RELEASE} are not available." >&2
exit 1
else
# user might have provided their own apt sources.list
if ! grep -q backports /etc/apt/sources.list.d/backports.list 2>/dev/null ; then
cat >> /etc/apt/sources.list.d/backports.list << EOF
# debian backports: ${RELEASE}-backports repository:
deb http://backports.debian.org/debian-backports ${RELEASE}-backports main
deb-src http://backports.debian.org/debian-backports ${RELEASE}-backports main
EOF
fi
fi
fi
}
# }}}
# set up kernel-img.conf {{{
kernelimg_conf() {
if ! [ -r /etc/kernel-img.conf ] ; then
echo "Setting up /etc/kernel-img.conf"
cat > /etc/kernel-img.conf << EOF
# Kernel Image management overrides
# See kernel-img.conf(5) for details
do_initrd = Yes
do_symlinks = Yes
EOF
fi
}
# }}}
# make sure services do not start up {{{
install_policy_rcd() {
if ! [ -r /usr/sbin/policy-rc.d ] ; then
export POLICYRCD=1
cat > /usr/sbin/policy-rc.d << EOF
#!/bin/sh
exit 101
EOF
chmod 775 /usr/sbin/policy-rc.d
fi
}
# }}}
# make sure we have an up2date system {{{
upgrade_system() {
if [ "$UPGRADE_SYSTEM" = "yes" ] ; then
echo "Running update + upgrade"
$APTUPDATE
$APTUPGRADE
else
echo "Not running update + upgrade as \$UPDATE_AND_UPGRADE is not set to 'yes'."
fi
}
# }}}
# remove now useless apt cache {{{
remove_apt_cache() {
if [ "$RM_APTCACHE" = 'yes' ] ; then
echo "Cleaning apt cache."
apt-get clean
else
echo "Not cleaning apt cache as \$RM_APTCACHE is unset."
fi
}
# }}}
# install additional packages {{{
packages() {
# Pre-seed the debconf database with answers. Each question will be marked
# as seen to prevent debconf from asking the question interactively.
[ -f /etc/debootstrap/debconf-selections ] && {
echo "Preseeding the debconf database, some lines might be skipped..."
cat /etc/debootstrap/debconf-selections | debconf-set-selections
}
if [ "$PACKAGES" = 'yes' ] ; then
if ! [ -r /etc/debootstrap/packages ] ; then
echo "Error: /etc/debootstrap/packages (inside chroot) not found, exiting." >&2
exit 1
else
$APTUPDATE
DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL $(grep -v '^#' /etc/debootstrap/packages) $GRMLPACKAGES
fi
fi
}
# }}}
# install extra packages {{{
extrapackages() {
if [ "$EXTRAPACKAGES" = 'yes' ] ; then
PACKAGELIST=$(find /etc/debootstrap/extrapackages -type f -name '*.deb')
if [ -n "$PACKAGELIST" ]; then
dpkg -i $PACKAGELIST
# run apt again to resolve any deps
DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL
fi
fi
}
# }}}
# check if the specified Debian package exists
package_exists() {
output=$(apt-cache show "$1" 2>/dev/null)
[ -n "$output" ]
return $?
}
# determine the kernel version postfix
get_kernel_version() {
# do not override $KERNEL if set via config file
if [ -n "$KERNEL" ] ; then
echo "$KERNEL"
return 0
fi
case $ARCH in
i386) KARCH=686 ;;
amd64) KARCH=amd64 ;;
*)
echo "Only i386 and amd64 are currently supported" >&2
return 1
esac
for KPREFIX in "" "2.6-" ; do # iterate through the kernel prefixes,
# currently "" and "2.6-"
if package_exists linux-image-${KPREFIX}${KARCH} ; then
echo ${KPREFIX}${KARCH}
return 0
fi
done
}
# install kernel packages {{{
kernel() {
$APTUPDATE
KVER=$(get_kernel_version)
if [ -n "$KVER" ] ; then
# note: install busybox to be able to debug initramfs
KERNELPACKAGES="linux-image-$KVER linux-headers-$KVER busybox firmware-linux-free firmware-linux"
DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL $KERNELPACKAGES
else
echo "Warning: Could not find a kernel for your system. Your system won't be able to boot itself!"
fi
}
# }}}
# reconfigure packages {{{
reconfigure() {
if [ -n "$RECONFIGURE" ] ; then
for package in $RECONFIGURE ; do
if dpkg --list $package >/dev/null 2>&1 | grep -q '^ii' ; then
DEBIAN_FRONTEND=$DEBIAN_FRONTEND dpkg-reconfigure $package || \
echo "Warning: $package does not exist, can not reconfigure it."
fi
done
fi
}
# }}}
# set password of user root {{{
passwords()
{
if [ -n "$NOPASSWORD" ] ; then
echo "Skip setting root password as requested."
return 0
fi
echo "Activating shadow passwords."
shadowconfig on
CHPASSWD_OPTION=
if chpasswd --help 2>&1 | grep -q -- '-m,' ; then
CHPASSWD_OPTION='-m'
fi
if [ -n "$ROOTPASSWORD" ] ; then
echo root:"$ROOTPASSWORD" | chpasswd $CHPASSWD_OPTION
export ROOTPASSWORD=''
else
a='1'
b='2'
echo "Setting password for user root:"
while [ "$a" != "$b" ] ; do
echo -n "Enter new UNIX password for user root: "
askpass
a="$resp"
unset resp
echo
echo -n "Retype new UNIX password for user root: "
askpass
b="$resp"
unset resp
echo
if [ "$a" != "$b" ] ; then
echo "Sorry, passwords do not match. Retry."
a='1'
b='2'
else
echo root:"$a" | chpasswd $CHPASSWD_OPTION
unset a
unset b
fi
done
fi
}
# }}}
# set up /etc/hosts {{{
hosts() {
if [ -f /etc/hosts ] ; then
sed -i "s#127.0.0.1 .*#127.0.0.1 localhost $HOSTNAME#" /etc/hosts
[ -n "$HOSTNAME" ] && sed -i "s/grml/$HOSTNAME/g" /etc/hosts
else
cat > /etc/hosts << EOF
127.0.0.1 localhost $HOSTNAME
#127.0.0.1 localhost
#127.0.1.1 $HOSTNAME.example.org $HOSTNAME
# The following lines are desirable for IPv6 capable hosts
#::1 ip6-localhost ip6-loopback $HOSTNAME
::1 ip6-localhost ip6-loopback
fe00::0 ip6-localnet
ff00::0 ip6-mcastprefix
ff02::1 ip6-allnodes
ff02::2 ip6-allrouters
ff02::3 ip6-allhosts
EOF
fi
}
# }}}
# set up /etc/network/interfaces {{{
interfaces() {
if ! [ -r /etc/network/interfaces ] || ! grep -q "auto lo" /etc/network/interfaces ; then
echo "Setting up /etc/network/interfaces"
cat >> /etc/network/interfaces << EOF
# loopback device:
iface lo inet loopback
auto lo
# eth0:
# iface eth0 inet dhcp
# auto eth0
EOF
fi
}
# }}}
# set default locales {{{
default_locales() {
if [ -n "$DEFAULT_LOCALES" ] ; then
if ! [ -x /usr/sbin/update-locale ] ; then
echo "Warning: update-locale executable not available (no locales package installed?)"
echo "Ignoring request to run update-locale for $DEFAULT_LOCALES therefore"
return 0
fi
/usr/sbin/update-locale LANG="$DEFAULT_LOCALES"
fi
}
# }}}
# adjust timezone {{{
timezone() {
if [ -n "$TIMEZONE" ] ; then
echo "Adjusting /etc/localtime"
ln -sf /usr/share/zoneinfo/$TIMEZONE /etc/localtime
fi
}
# }}}
# helper function for fstab() {{{
createfstab(){
echo "Setting up /etc/fstab"
if [ -n "$TARGET_UUID" ] ; then
echo "/dev/disk/by-uuid/${TARGET_UUID} / auto defaults,errors=remount-ro 0 1" > /etc/fstab
else
echo "${TARGET} / auto defaults,errors=remount-ro 0 1" > /etc/fstab
fi
cat >> /etc/fstab << EOF
proc /proc proc defaults 0 0
/dev/cdrom /mnt/cdrom0 iso9660 ro,user,noauto 0 0
# some other examples:
# /dev/sda2 none swap sw,pri=0 0 0
# /dev/hda1 /Grml ext3 dev,suid,user,noauto 0 2
# //1.2.3.4/pub /smb/pub smbfs defaults,user,noauto,uid=grml,gid=grml 0 0
# linux:/pub /beer nfs defaults 0 0
# tmpfs /tmp tmpfs size=300M 0 0
# /dev/sda5 none swap sw 0 0
EOF
}
# }}}
# generate /etc/fstab {{{
fstab() {
# set up /etc/fstab if file is not present (cdebootstrap)
if [ ! -f /etc/fstab ] ; then
createfstab
fi
# set up /etc/fstab if file is UNCONFIGURED (debootstrap)
if grep -q UNCONFIGURED /etc/fstab ; then
createfstab
fi
}
# }}}
# set up hostname {{{
hostname() {
if [ -n "$HOSTNAME" ] ; then
echo "Setting hostname to ${HOSTNAME}."
echo "$HOSTNAME" > /etc/hostname
# adjust postfix configuration
if [ -r /etc/postfix/main.cf ] ; then
# adjust hostname related options:
sed -i "s/grml/$HOSTNAME/g" /etc/postfix/main.cf
# listen on loopback interface only:
sed -i "s/^inet_interfaces = .*/inet_interfaces = loopback-only/" /etc/postfix/main.cf
grep -q inet_interfaces /etc/postfix/main.cf || echo 'inet_interfaces = loopback-only' >> /etc/postfix/main.cf
fi
fi
}
# }}}
# generate initrd/initramfs {{{
initrd() {
# assume the first available kernel as our main kernel
KERNELIMG=$(ls -1 /boot/vmlinuz-* 2>/dev/null | head -1)
if [ -z "$KERNELIMG" ] ; then
echo 'No kernel image found, skipping initrd stuff.'>&2
return
fi
KERNELVER=${KERNELIMG#/boot/vmlinuz-}
# generate initrd
if [ -n "$INITRD" ] ; then
echo "Generating initrd."
update-initramfs -c -t -k $KERNELVER
fi
}
# }}}
# grub configuration/installation {{{
grub_install() {
if [ -z "$GRUB" ] ; then
echo "Notice: \$GRUB not defined, will not install grub inside chroot at this stage."
return 0
fi
if ! dpkg --list grub-pc 2>/dev/null | grep -q '^ii' ; then
echo "Notice: grub option set but no grub-pc package, installing it therefore."
DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL grub-pc
fi
if ! [ -x "$(which grub-install)" ] ; then
echo "Error: grub-install not available. (Error while installing grub package?)" >&2
return 1
fi
if [ -n "$SELECTED_PARTITIONS" ] ; then # using sw-raid
for device in $SELECTED_PARTITIONS ; do
GRUB="${device%%[0-9]}"
echo "Installing grub on ${GRUB}:"
grub-install --no-floppy "$GRUB"
done
else
echo "Installing grub on ${GRUB}:"
grub-install --no-floppy "$GRUB"
fi
echo "Adjusting grub configuration for use on ${GRUB}."
# finally install grub
if [ -x /usr/sbin/update-grub ] ; then
UPDATEGRUB='/usr/sbin/update-grub'
elif [ -x /sbin/update-grub ] ; then
UPDATEGRUB='/sbin/update-grub'
else
echo "Error: update-grub not available, can not execute it." >&2
return 1
fi
$UPDATEGRUB
}
# }}}
# execute all scripts present in /etc/debootstrap/chroot-scripts/ {{{
custom_scripts() {
[ -d /etc/debootstrap/chroot-scripts/ ] || return 0
for script in /etc/debootstrap/chroot-scripts/* ; do
echo "Executing script $script"
$script && echo "done" || echo "failed"
done
}
# }}}
# make sure we don't have any running processes left {{{
services() {
for service in ssh mdadm mdadm-raid ; do
if [ -x /etc/init.d/"$service" ] ; then
/etc/init.d/"$service" stop || true
fi
done
}
# }}}
# unmount /proc and make sure nothing is left {{{
finalize() {
# make sure we don't leave any sensible data
rm -f /etc/debootstrap/variables
[ -n "$POLICYRCD" ] && rm -f /usr/sbin/policy-rc.d
umount /proc >/dev/null 2>/dev/null || true
}
# }}}
# signal handler {{{
signal_handler() {
finalize
[ -n "$1" ] && EXIT="$1" || EXIT="1"
exit "$EXIT"
}
# }}}
# set signal handler {{{
trap signal_handler HUP INT QUIT TERM
# }}}
# execute the functions {{{
# always execute install_policy_rcd
install_policy_rcd
for i in chrootmirror grmlrepos backportrepos kernelimg_conf \
kernel packages extrapackages reconfigure hosts interfaces \
default_locales timezone fstab hostname initrd grub_install passwords \
custom_scripts upgrade_system remove_apt_cache services \
remove_chrootmirror; do
if stage $i ; then
$i && stage $i done || exit 1
fi
done
# always execute the finalize stage:
finalize
# }}}
# finally exit the chroot {{{
echo "Finished chroot installation, exiting."
exit 0
# }}}
## END OF FILE #################################################################
# vim: ai tw=80 expandtab foldmethod=marker
|